var MessageHolder;
var EnemyTable;
var PlayerTable;

var player_data = new Array(10);
var enemy_data = new Array(10);
var player_ships = new Array(5);
var enemy_ships = new Array(5);

var ShipTypes = new Array(7);

var EndOfBattle;
var EnemyTurn;

var IsSoundEnabled = "enabled";
var IsRandomDeployment = "disabled";

var Deploy;
var DeployOrientation;
var DeployX, DeployY;

function Init()
{
	if (System.Gadget.Settings.read("RandomDeployment") == "enabled")
		MessageHolder.innerHTML = START_ATTACK;
	else
		MessageHolder.innerHTML = DEPLOY_MINESWEEPER;
	EnemyTable.innerHTML = "";
	PlayerTable.innerHTML = "";
	
	InitArrays();
	SetUpShips();
	
	EndOfBAttle = false;
	EnemyTurn = false;
	
	Deploy = "Minesweeper";
	DeployOrientation = "h";
}

function Player_OnMouseMove()
{
	if (IsRandomDeployment == "enabled") Deploy = "NO";
	if (Deploy == "NO") return;

	DeployX = Math.floor((window.event.clientX - 5) / 12);
	DeployY = Math.floor((window.event.clientY - 174) / 12);
	
	if (DeployOrientation == "h" && DeployX > 10 - ShipTypes[Deploy])
		DeployX = 10 - ShipTypes[Deploy];
	if (DeployOrientation == "v" && DeployY > 10 - ShipTypes[Deploy])
		DeployY = 10 -ShipTypes[Deploy];
	
	PlayerTable.innerHTML = "";
	var temp = "";
	
	switch (Deploy)
	{
		case "Minesweeper":
			break;
		case "Submarine":
			temp += DrawShip("Minesweeper", player_ships["Minesweeper"][2], 
							player_ships["Minesweeper"][0], player_ships["Minesweeper"][1]);
			break;
		case "Frigate":
			temp += DrawShip("Minesweeper", player_ships["Minesweeper"][2], 
							player_ships["Minesweeper"][0], player_ships["Minesweeper"][1]);
			temp += DrawShip("Submarine", enemy_ships["Submarine"][2], 
							player_ships["Submarine"][0], player_ships["Submarine"][1]);
			break;
		case "Battleship":
			temp += DrawShip("Minesweeper", player_ships["Minesweeper"][2], 
							player_ships["Minesweeper"][0], player_ships["Minesweeper"][1]);
			temp += DrawShip("Submarine", player_ships["Submarine"][2], 
							player_ships["Submarine"][0], player_ships["Submarine"][1]);
			temp += DrawShip("Frigate", player_ships["Frigate"][2], 
							player_ships["Frigate"][0], player_ships["Frigate"][1]);
			break;
		case "Carrier":
			temp += DrawShip("Minesweeper", player_ships["Minesweeper"][2], 
							player_ships["Minesweeper"][0], player_ships["Minesweeper"][1]);
			temp += DrawShip("Submarine", player_ships["Submarine"][2], 
							player_ships["Submarine"][0], player_ships["Submarine"][1]);
			temp += DrawShip("Frigate", player_ships["Frigate"][2], 
							player_ships["Frigate"][0], player_ships["Frigate"][1]);
			temp += DrawShip("Battleship", player_ships["Battleship"][2], 
							player_ships["Battleship"][0], player_ships["Battleship"][1]);
			break;
	}
	
	PlayerTable.innerHTML += temp + DrawShip(Deploy, DeployOrientation, DeployX, DeployY);
}

function Player_OnClick(e)
{
	if (IsRandomDeployment == "enabled") Deploy = "NO";
	if (Deploy == "NO") return;

	if (e.button == 1)
	{
		if (IsPlaceable("player", Deploy, DeployOrientation, DeployX, DeployY))
		{
			player_ships[Deploy][0] = DeployX;
			player_ships[Deploy][1] = DeployY;
			player_ships[Deploy][2] = DeployOrientation;
			player_ships[Deploy][3] = 0;
		
			for (var i = 0; i < ShipTypes[Deploy]; i++)
			{
				if 	(DeployOrientation == "h") player_data[DeployX + i][DeployY] = Deploy;
				if 	(DeployOrientation == "v") player_data[DeployX][DeployY + i] = Deploy;
			}
			
			switch (Deploy)
			{
				case "Minesweeper": 
					MessageHolder.innerHTML = DEPLOY_SUBMARINE;
					Deploy = "Submarine"; 
					break;
				case "Submarine": 
					MessageHolder.innerHTML = DEPLOY_FRIGATE;
					Deploy = "Frigate";
					break;
				case "Frigate": 
					MessageHolder.innerHTML = DEPLOY_BATTLESHIP;
					Deploy = "Battleship"; 
					break;
				case "Battleship": 
					MessageHolder.innerHTML = DEPLOY_CARRIER;
					Deploy = "Carrier";
					break;
				case "Carrier": 
					MessageHolder.innerHTML = START_ATTACK;
					Deploy = "NO"; 
					break;
			}
			
			Player_OnMouseMove();
		}
		else MessageHolder.innerHTML = NOT_PLACEABLE;
	}
	else if (e.button == 4)
	{
		if (DeployOrientation == "h") DeployOrientation = "v";
		else if (DeployOrientation == "v") DeployOrientation = "h";
	}
}

function IsPlaceable(who, type, orientation, x, y)
{
	var i;
	
	if (who == "player")
	{
		for (i = 0; i < ShipTypes[type]; i++)
		{
			if	(orientation == "h" && player_data[x + i][y] != "EMPTY") return false;
			if 	(orientation == "v" && player_data[x][y + i] != "EMPTY") return false;
		}
	}
	else if (who == "enemy")
	{
		for (i = 0; i < ShipTypes[type]; i++)
		{
			if (orientation == "h" && enemy_data[x + i][y] != "EMPTY") return false;
			if (orientation == "v" && enemy_data[x][y + i] != "EMPTY") return false;
		}
	}
	
	return true;
}

function PlaceShip(type, who)
{
	var o, x, y, max_x, max_y;
	
	if (Math.random() > 0.5) o = "h";
	else o = "v";
	
	if (o == "h")
	{
		max_x = 10 - ShipTypes[type];
		max_y = 10;
	}
	else if (o == "v")
	{
		max_x = 10;
		max_y = 10 - ShipTypes[type];	
	}
	
	x = Math.floor(Math.random() * max_x);
	y = Math.floor(Math.random() * max_y);
	while (!IsPlaceable(who, type, o, x, y))
	{
		x = Math.floor(Math.random() * max_x);
		y = Math.floor(Math.random() * max_y);
	}
	
	if (who == "player")
	{
		for (var i = 0; i < ShipTypes[type]; i++)
		{
			if 	(o == "h")
			{
				player_data[x + i][y] = type;
				player_ships[type][0] = x;
				player_ships[type][1] = y;
				player_ships[type][2] = "h";
				player_ships[type][3] = 0;
			}
			if 	(o == "v")
			{
				player_data[x][y + i] = type;
				player_ships[type][0] = x;
				player_ships[type][1] = y;
				player_ships[type][2] = "v";
				player_ships[type][3] = 0;
			}
		}
		
		PlayerTable.innerHTML += DrawShip(type, o, x, y);
	}
	else if (who == "enemy")
	{
		for (var i = 0; i < ShipTypes[type]; i++)
		{
			if 	(o == "h")
			{
				enemy_data[x + i][y] = type;
				enemy_ships[type][0] = x;
				enemy_ships[type][1] = y;
				enemy_ships[type][2] = "h";
				enemy_ships[type][3] = 0;
			}
			if 	(o == "v")
			{
				enemy_data[x][y + i] = type;
				enemy_ships[type][0] = x;
				enemy_ships[type][1] = y;
				enemy_ships[type][2] = "v";
				enemy_ships[type][3] = 0;
			}
		}
	}
}

function SetUpShips()
{
	PlaceShip("Minesweeper", "enemy");
	PlaceShip("Submarine", "enemy");	
	PlaceShip("Frigate", "enemy");	
	PlaceShip("Battleship", "enemy");	
	PlaceShip("Carrier", "enemy");
	
	if (IsRandomDeployment == "enabled")
	{
		PlaceShip("Minesweeper", "player");
		PlaceShip("Submarine", "player");	
		PlaceShip("Frigate", "player");	
		PlaceShip("Battleship", "player");	
		PlaceShip("Carrier", "player");
	}
}

function InitArrays()
{
	for (var i = 0; i < 10; i++)
	{
		player_data[i] = new Array(10);
		enemy_data[i] = new Array(10);
		
		for (var j = 0; j < 10; j++)
		{
			player_data[i][j] = "EMPTY";
			enemy_data[i][j] = "EMPTY";
		}
	}
	
	player_ships["Minesweeper"] = new Array(4);
	player_ships["Submarine"] = new Array(4);
	player_ships["Frigate"] = new Array(4);
	player_ships["Battleship"] = new Array(4);
	player_ships["Carrier"] = new Array(4);
	for (a in player_ships)
		for (i = 0; i < 4; i++) a[i] = "";
	
	enemy_ships["Minesweeper"] = new Array(4);
	enemy_ships["Submarine"] = new Array(4);
	enemy_ships["Frigate"] = new Array(4);
	enemy_ships["Battleship"] = new Array(4);
	enemy_ships["Carrier"] = new Array(4);
	for (a in enemy_ships)
		for (i = 0; i < 4; i++) a[i] = "";
	
	ShipTypes["Minesweeper"] = 2;
	ShipTypes["Submarine"] = 3;
	ShipTypes["Frigate"] = 3;
	ShipTypes["Battleship"] = 4;
	ShipTypes["Carrier"] = 5;
	ShipTypes["Try"] = 6;
	ShipTypes["Shot"] = 7;
}

function DrawShip(type, orientation, x, y)
{
	var size = ShipTypes[type];
	
	var html = "<img src=\"../images/ship" + size + "_" + orientation +
				".png\" style=\"position:absolute; left:" + x * 12 + "px; top:" + y * 12 + "px;\" />";
	
	return html;
}

function Torpedo_OnLoad()
{
	System.Gadget.settingsUI = "Settings.html";
	System.Gadget.onSettingsClosed = SettingsOnClosed;
	
	EnemyTable = document.getElementById("enemy");
	PlayerTable = document.getElementById("player");
	MessageHolder = document.getElementById("message");
	
	Init();
	
	System.Gadget.Settings.write("EnableSound", "enabled");
	System.Gadget.Settings.write("RandomDeployment", "disabled");
}

function SettingsOnClosed(event)
{
    if (event.closeAction == event.Action.commit)
    {
		IsSoundEnabled = System.Gadget.Settings.readString("EnableSound");
		IsRandomDeployment = System.Gadget.Settings.readString("RandomDeployment");
	}
    else if (event.closeAction == event.Action.cancel)
    {
    }
}

function Pause(t)
{
	d = new Date();
    while (1)
    {
     	mill=new Date();
        diff = mill-d;
        if( diff > t ) {break;}
    }
}

function PlayerMove()
{
	var x = Math.floor((window.event.clientX - 5) / 12);
	var y = Math.floor((window.event.clientY - 39) / 12);
	
	switch(enemy_data[x][y])
	{
		case "EMPTY":
			EnemyTable.innerHTML += DrawShip("Try", "", x, y);
			enemy_data[x][y] = "TRY";
			MessageHolder.innerHTML = TRY;
			PlaySound("../sounds/try.wav");
		 	break;
		case "TRY":
			MessageHolder.innerHTML = ALREADY_TRIED;
		 	return false;
			break;
		case "SHOT":
			MessageHolder.innerHTML = ALREADY_TRIED;
			return false;
		 	break;
		case "Minesweeper":
			EnemyTable.innerHTML += DrawShip("Shot", "", x, y);
			enemy_ships["Minesweeper"][3]++;
			enemy_data[x][y] = "SHOT";
			MessageHolder.innerHTML = ENEMY_MINESWEEPER_HIT;
			PlaySound("../sounds/shot.wav");
			if (enemy_ships["Minesweeper"][3] == 2) 
			{
				MessageHolder.innerHTML = ENEMY_MINESWEEPER_DESTROYED;
				var temp = EnemyTable.innerHTML;
				EnemyTable.innerHTML = DrawShip("Minesweeper", 
												enemy_ships["Minesweeper"][2], 
												enemy_ships["Minesweeper"][0], 
												enemy_ships["Minesweeper"][1]);
				EnemyTable.innerHTML += temp;
			}
		 	break;
		case "Submarine":
			EnemyTable.innerHTML += DrawShip("Shot", "", x, y);
			enemy_ships["Submarine"][3]++;
			enemy_data[x][y] = "SHOT";
			MessageHolder.innerHTML = ENEMY_SUBMARINE_HIT;
			PlaySound("../sounds/shot.wav");
			if (enemy_ships["Submarine"][3] == 3) 
			{
				MessageHolder.innerHTML = ENEMY_SUBMARINE_DESTROYED;
				var temp = EnemyTable.innerHTML;
				EnemyTable.innerHTML = DrawShip("Submarine", 
												enemy_ships["Submarine"][2], 
												enemy_ships["Submarine"][0], 
												enemy_ships["Submarine"][1]);
				EnemyTable.innerHTML += temp;
			}
		 	break;
		case "Frigate":
			EnemyTable.innerHTML += DrawShip("Shot", "", x, y);
			enemy_ships["Frigate"][3]++;
			enemy_data[x][y] = "SHOT";
			MessageHolder.innerHTML = ENEMY_FRIGATE_HIT;
			PlaySound("../sounds/shot.wav");
			if (enemy_ships["Frigate"][3] == 3) 
			{
				MessageHolder.innerHTML = ENEMY_FRIGATE_DESTROYED;
				var temp = EnemyTable.innerHTML;
				EnemyTable.innerHTML = DrawShip("Frigate", 
												enemy_ships["Frigate"][2], 
												enemy_ships["Frigate"][0], 
												enemy_ships["Frigate"][1]);
				EnemyTable.innerHTML += temp;
			}
		 	break;
		case "Battleship":
			EnemyTable.innerHTML += DrawShip("Shot", "", x, y);
			enemy_ships["Battleship"][3]++;
			enemy_data[x][y] = "SHOT";
			MessageHolder.innerHTML = ENEMY_BATTLESHIP_HIT;
			PlaySound("../sounds/shot.wav");
			if (enemy_ships["Battleship"][3] == 4) 
			{
				MessageHolder.innerHTML = ENEMY_BATTLESHIP_DESTROYED;
				var temp = EnemyTable.innerHTML;
				EnemyTable.innerHTML = DrawShip("Battleship", 
												enemy_ships["Battleship"][2], 
												enemy_ships["Battleship"][0], 
												enemy_ships["Battleship"][1]);
				EnemyTable.innerHTML += temp;
			}
		 	break;
		case "Carrier":
			EnemyTable.innerHTML += DrawShip("Shot", "", x, y);
			enemy_ships["Carrier"][3]++;
			enemy_data[x][y] = "SHOT";
			MessageHolder.innerHTML = ENEMY_CARRIER_HIT;
			PlaySound("../sounds/shot.wav");
			if (enemy_ships["Carrier"][3] == 5) 
			{
				MessageHolder.innerHTML = ENEMY_CARRIER_DESTROYED;
				var temp = EnemyTable.innerHTML;
				EnemyTable.innerHTML = DrawShip("Carrier", 
												enemy_ships["Carrier"][2], 
												enemy_ships["Carrier"][0], 
												enemy_ships["Carrier"][1]);
				EnemyTable.innerHTML += temp;
			}
		 	break;
	}	
	
	if (enemy_ships["Minesweeper"][3] == 2 &&
		enemy_ships["Submarine"][3] == 3 &&
		enemy_ships["Frigate"][3] == 3 &&
		enemy_ships["Battleship"][3] == 4 &&
		enemy_ships["Carrier"][3] == 5)
	{
		MessageHolder.innerHTML = PLAYER_WIN;
		EndOfBattle = true;
	}
	return true;
}

function ShotHere(x, y)
{
	if (x > 9 || x < 0 || y > 9 || y < 0) return false;
	
	if (player_data[x][y] == "EMPTY" ||
		player_data[x][y] == "Minesweeper" ||
		player_data[x][y] == "Submarine" ||
		player_data[x][y] == "Frigate" ||
		player_data[x][y] == "Battleship" ||
		player_data[x][y] == "Carrier")
	return true;
	else return false;
}

function EnemyMove()
{
	var i, j;
	var x = -1;
	var y = -1;
	
	for (i = 0; i < 10; ++i)
		for (j = 0; j < 10; ++j)
		{
			if (player_data[i][j] == "SHOT")
			{
				if (player_data[i  + 1][j] == "SHOT")
				{
					if (ShotHere(i + 2, j))
					{ 
						x = i + 2; 
						y = j; 
						break;
					}
					else if (ShotHere(i - 1, j))
					{
						x = i - 1;
						y = j;
						break;
					}
				}
				else if (player_data[i][j + 1] == "SHOT")
				{
					if (ShotHere(i, j + 2))
					{ 
						x = i; 
						y = j + 2; 
						break;
					}
					else if (ShotHere(i, j - 1))
					{
						x = i;
						y = j - 1;
						break;
					}	
				}
				else
				{
					if (ShotHere(i + 1, j)) { x = i + 1; y = j; break; }
					else if (ShotHere(i - 1, j)) { x = i - 1; y = j; break; }
					else if (ShotHere(i, j + 1)) { x = i; y = j + 1; break; }
					else if (ShotHere(i, j - 1)) { x = i; y = j - 1; break; }
				}
			}
			
		}
		
	if (x == -1 && y == -1)
	{
		while (!ShotHere(x, y))
		{
			x = Math.floor(Math.random() * 10);
			y = Math.floor(Math.random() * 10);
		}
	}
	
	switch(player_data[x][y])
	{
		case "EMPTY":
			PlayerTable.innerHTML += DrawShip("Try", "", x, y);
			player_data[x][y] = "TRY";
			MessageHolder.innerHTML = TRY;
			PlaySound("../sounds/try.wav");
			break;
		case "Minesweeper":
			PlayerTable.innerHTML += DrawShip("Shot", "", x, y);
			player_ships["Minesweeper"][3]++;
			player_data[x][y] = "SHOT";
			MessageHolder.innerHTML = PLAYER_MINESWEEPER_HIT;
			PlaySound("../sounds/shot.wav");
				if (enemy_ships["Minesweeper"][3] == 2) MessageHolder.innerHTML = PLAYER_MINESWEEPER_DESTROYED;
			break;
		case "Submarine":
			PlayerTable.innerHTML += DrawShip("Shot", "", x, y);
			player_ships["Submarine"][3]++;
			player_data[x][y] = "SHOT";
			MessageHolder.innerHTML = PLAYER_SUBMARINE_HIT;
			PlaySound("../sounds/shot.wav");
			if (player_ships["Submarine"][3] == 3) MessageHolder.innerHTML = PLAYER_SUBMARINE_DESTROYED;
	 		break;
		case "Frigate":
			PlayerTable.innerHTML += DrawShip("Shot", "", x, y);
			player_ships["Frigate"][3]++;
			player_data[x][y] = "SHOT";
			MessageHolder.innerHTML = PLAYER_FRIGATE_HIT;
			PlaySound("../sounds/shot.wav");
			if (player_ships["Frigate"][3] == 3) MessageHolder.innerHTML = PLAYER_FRIGATE_DESTROYED;
	 		break;
		case "Battleship":
			PlayerTable.innerHTML += DrawShip("Shot", "", x, y);
			player_ships["Battleship"][3]++;
			player_data[x][y] = "SHOT";
			MessageHolder.innerHTML = PLAYER_BATTLESHIP_HIT;
			PlaySound("../sounds/shot.wav");
			if (player_ships["Battleship"][3] == 4) MessageHolder.innerHTML = PLAYER_BATTLESHIP_DESTROYED;
	 		break;
		case "Carrier":
			PlayerTable.innerHTML += DrawShip("Shot", "", x, y);
			player_ships["Carrier"][3]++;
			player_data[x][y] = "SHOT";
			MessageHolder.innerHTML = PLAYER_CARRIER_HIT;
			PlaySound("../sounds/shot.wav");
			if (player_ships["Carrier"][3] == 5) MessageHolder.innerHTML = PLAYER_CARRIER_DESTROYED;
	 		break;
	}
	
	if (player_ships["Minesweeper"][3] == 2 &&
		player_ships["Submarine"][3] == 3 &&
		player_ships["Frigate"][3] == 3 &&
		player_ships["Battleship"][3] == 4 &&
		player_ships["Carrier"][3] == 5)
	{
		MessageHolder.innerHTML = ENEMY_WIN;
		
		var temp = EnemyTable.innerHTML;
		EnemyTable.innerHTML = DrawShip("Minesweeper", enemy_ships["Minesweeper"][2], 
										enemy_ships["Minesweeper"][0], enemy_ships["Minesweeper"][1]);
		EnemyTable.innerHTML += DrawShip("Submarine", enemy_ships["Submarine"][2], 
										enemy_ships["Submarine"][0], enemy_ships["Submarine"][1]);
		EnemyTable.innerHTML += DrawShip("Frigate", enemy_ships["Frigate"][2], 
										enemy_ships["Frigate"][0], enemy_ships["Frigate"][1]);
		EnemyTable.innerHTML += DrawShip("Battleship", enemy_ships["Battleship"][2], 
										enemy_ships["Battleship"][0], enemy_ships["Battleship"][1]);
		EnemyTable.innerHTML += DrawShip("Carrier", enemy_ships["Carrier"][2], 
										enemy_ships["Carrier"][0], enemy_ships["Carrier"][1]);
		EnemyTable.innerHTML += temp;
		
		EndOfBattle = true;
	}
}

function Enemy_OnMouseDown()
{	
	if (EndOfBattle || EnemyTurn || Deploy != "NO") return;
	
	EnemyTurn = PlayerMove();
}

function Enemy_OnMouseUp()
{
	if (EndOfBattle || Deploy != "NO") return;
	
	if (EnemyTurn)
	{
		if (IsSoundEnabled == "enabled") Pause(1800);
		else Pause(500);
		EnemyMove();
		EnemyTurn = false;
	}
}

function PlaySound(soundfile)
{
	if (IsSoundEnabled == "disabled") return;
	
	if (document.all && document.getElementById)
	{
		document.getElementById("soundeffect").src="";
		document.getElementById("soundeffect").src=soundfile;
	}
}

function NewGame_OnClick()
{
	Init();
}